// IvCameraTextField.c++

#include "IvCameraTextField.h++"
#include <stream.h>

IvCameraTextField::IvCameraTextField()
  : root( new SoSeparator ),
    xform( new SoTransform ),
    colorIndex( new SoColorIndex ),
    text( new SoText2 )
{
    root -> ref();
    root -> addChild( xform );
    root -> addChild( colorIndex );
    root -> addChild( text );
    setLocation( -.48, 0 );
    // setText( "hello" );
    setColor( 2 );
}

void
IvCameraTextField::setText( const char *s )
{
    text -> string.set1Value( 0, s );
}

void
IvCameraTextField::setColor( int i )
{
    colorIndex -> index = i;
}

void
IvCameraTextField::setLocation( float u, float v )
{
    xform -> translation.setValue( u, v, 0 );
}
