// qmVector.h++

#ifndef _qmVector_H_
#define _qmVector_H_

#include <stddef.h>
#include <stream.h>
#include <assert.h>
#include "QuickMath/qmReal.h++"
#include "QuickMath/qmVectorRef.h++"

class qmVector : public qmVectorRef
{
    real *allocArray;
public:
    virtual ~qmVector() { if( allocArray ) delete [] allocArray; }
    qmVector( )
      : qmVectorRef( ), allocArray(0) {}
    qmVector( int n );
    qmVector( int n, real *data );
    qmVector( const qmVector& );
    qmVector( const qmVectorRef& );
    qmVector& set( int n );
    qmVector& set( int n, real *data );
    qmVector& set( const qmVectorRef& );
    qmVector& operator=( const qmVectorRef& qv ) { return set(qv); }
};

#endif /* _qmVector_H_ */
