// sffinder.c++
#include "Parse/Parse.h++"
#include "FfinderClient.h++"
#include "SffinderServer.h++"
#include "ComputeGeometry.h++"
#define Time XXXTime
#include "PersonViewer.h++"
#undef Time
#include "PersonPlus.h++"
#include "Useless/HowSlow.h++"
#include "SffFile.h++"

static
inline
void
setState( PersonPlus& pp, ComputeGeometry& cg, int& perstate )
{
#if 0
    pp.setState( ffinderClient.getLeftState(),
		 ffinderClient.getRightState() );
#endif
    pp.setState();
    switch( pp.getState() )
       {
	case PersonPlus::NoPerson:
	   cg.setMode( cg.NOMODE );
	   break;
	case PersonPlus::ValidPerson:
	   switch( perstate )
	      {
	       case PersonPlus::NoPerson: cg.setMode( cg.BLOB ); break;
	       default: cg.setMode( cg.YAKKA );
	      }
	   break;
	case PersonPlus::InvalidPerson:
	   break;
       }
    perstate = pp.getState();
}

static void
ignore(...)
{
    return;
}

int
main( int argc, char *argv[] )
{
    int ffinderMode = 1;
    int undumpMode = 0;
    int dumpMode = 0;
    int collectMode = 0;
    int serveMode = 0;
    int displayMode = 0;
    char* dumpFilename = 0;
    int dumpNumber = 0;
    int dumpSkip = 0;
    int syncMode = 0;
    int noShitDump = 0;
    int moveDump = 0;

    ParseRuleTag( "undump", undumpMode, 1, "undump mode on" );
    ParseRuleTag( "undump", ffinderMode, 0, "ffinder mode off" );
    ParseRuleTag( "undump", dumpMode, 0, "dump mode off" );
    ParseRuleTaggedArg( "undump", dumpFilename, "undump filename",
			"filename" );
    ParseRuleTag( "dump", dumpMode, 1, "dump mode on" );
    ParseRuleTag( "dump", undumpMode, 0, "undump mode off" );
    ParseRuleTag( "dump", ffinderMode, 1, "ffinder mode on" );
    ParseRuleTaggedArg( "dump", dumpFilename, "dump filename", "filename" );
    ParseRuleTaggedArgInt( "dump", dumpNumber, "dump number", "num" );
    ParseRuleTaggedArgInt( "dump", dumpSkip, "dump skip", "skip" );
    ParseRuleTag( "collect", collectMode, 1, "collect mode on" );
    ParseRuleTag( "collect", dumpMode, 1, "dump mode on" );
    ParseRuleTag( "collect", undumpMode, 0, "undump mode off" );
    ParseRuleTag( "collect", ffinderMode, 1, "ffinder mode on" );
    ParseRuleTaggedArgInt( "collect", dumpNumber, "dump number", "num" );
    ParseRuleTaggedArgInt( "collect", dumpSkip, "dump skip", "skip" );
    ParseRuleTag( "serve", serveMode, 1, "serve mode on" );
    ParseRuleTag( "dpy", displayMode, 1, "display mode on" );
    ParseRuleTag( "sync", syncMode, 1, "sync mode on" );
    ParseRuleTag( "noshit", noShitDump, 1, "no shit in dump" );
    ParseRuleTag( "movedump", moveDump, 1, "move dump" );

    int width = 280;
    int height = 210;
    int x0 = 35;
    int y0 = -80;

    ParseRuleTaggedArgInt( "s", width, "width" );
    ParseRuleTaggedArgInt( "s", height, "height" );
    ParseRuleTaggedArgInt( "g", x0, "x0" );
    ParseRuleTaggedArgInt( "g", y0, "y0" );

    char* sffFilename = "stive.sff";
    ParseRuleTaggedArg( "config", sffFilename, "filename of config data" );

    int howslowMode = 0;
    ParseRuleTag( "howslow", howslowMode, 1, "howslow mode" );

    int computeMode = ComputeGeometry::YAKKA;
    ParseRuleFlag( 't', computeMode, (int)ComputeGeometry::TRIANGLE, 
		   "triangle mode" );
    ParseRuleFlag( 'b', computeMode, (int)ComputeGeometry::BLOB, 
		   "blob mode" );
    ParseRuleFlag( 'y', computeMode, (int)ComputeGeometry::YAKKA, 
		   "yakka mode" );
    ParseRuleTag( "wak", ComputeGeometry::wakkaFooMode, 1, "Wakka, do" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaHoo[0], "hdwakkaX" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaHoo[1], "hdwakkaY" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaHoo[2], "hdwakkaZ" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaFoo[0], "wakkaX" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaFoo[1], "wakkaY" );
    ParseRuleTaggedArgFloat( "wak", ComputeGeometry::wakkaFoo[2], "wakkaZ" );

    int worldMode = 1;
    ParseRuleTag( "world", worldMode, 1, "world coords" );

//     ParseRuleTaggedArgFloat( "blobtol", lmAbsTol, "blob tol" );
//     int blobMode = 0;
//     ParseRuleTag( "blob", blobMode, 1, "blob coords" );

    // ParseRuleFlag( 'y', yakkaMode, 1, "Yakka, dakka, do" );
    ParseRuleTaggedArgFloat( "yP", ComputeGeometry::yakkaT, "yakkaT" );
    ParseRuleTaggedArgFloat( "yP", ComputeGeometry::yakkaW, "yakkaW" );
    ParseRuleTaggedArgFloat( "yP", ComputeGeometry::yakkaL, "yakkaL" );
    ParseRuleTaggedArgFloat( "yQ", ComputeGeometry::yakkaDT, "yakkaDT" );
    ParseRuleTaggedArgFloat( "yQ", ComputeGeometry::yakkaDW, "yakkaDW" );
    ParseRuleTaggedArgFloat( "yQ", ComputeGeometry::yakkaDL, "yakkaDL" );
    ParseRuleTaggedArgFloat( "yR", ComputeGeometry::yakkaUV, "yakkaUV" );
    ParseRuleTaggedArgFloat( "yR", ComputeGeometry::yakkaS, "yakkaS" );

    int verbose = 0;
    ParseRuleFlag( 'v', verbose, 1, "verbose mode" );
    
    int displayDebug = 0;
    ParseRuleTag( "ddpy", displayDebug, 1, "display debug objects" );
    ParseRuleTag( "ddpy", displayMode, 1, "display on" );

    ParseRuleTag( "kalman", ComputeGeometry::kalmanMode, 1,
		  "kalman filtering mode" );
    ParseRuleTaggedArgFloat( "kalman", ComputeGeometry::dynNoiseVar,
			     "dynamic noise var", "q" );
    ParseRuleTaggedArgFloat( "kalman", ComputeGeometry::mmtNoiseVar,
			     "mmt noise var", "r" );

    char* libPath = ".";
    ParseRuleTaggedArg( "path", libPath, "library path", "path" );

    int undumpComputeMode = 0;
    ParseRuleTag( "udcomp", undumpComputeMode, 1, "undump compute mode" );

    ParseRuleTaggedArgFloat( "rd", PersonViewer::rayDepth, "ray depth",
			     "depth" );

    int stateMode = 0;
    ParseRuleTag( "state", stateMode, 1, "state mode" );

    ParseRuleTaggedArgFloat( "mt", PersonPlus::moveThresh, "move thresh"
			     "thresh" );

    ParseRuleTaggedArgFloat( "caltol", ComputeGeometry::calibTol, 
			     "calibration relative tolerance", "reltol" );
    ParseRuleTaggedArgFloat( "caltol", ComputeGeometry::calibAbstol, 
			     "calibration absolute tolerance", "abstol" );

    ParseRuleTag( "qp", PersonViewer::qpMode, 1, "quick points" );

    if( Parse::ParseCmdLine( argc, argv ) )
       {
	   Parse::Usage( argv[0] );
	   Parse::VerboseParse();
	   Parse::ParseCmdLine( argc, argv );
	   exit(1);
       }

    if( !dumpMode && !serveMode && !displayMode )
       serveMode = 1;

    SffFile sffFile;
    SffinderServer sffinderServer;
    PersonViewer personViewer;
    FfinderClient ffinderClient;
    ComputeGeometry computeGeometry;
    PersonPlus personPlus;

    chdir( libPath );
    // sffFile.setPath( libPath );
    if( sffFile.scan( sffFilename ) )
       exit( 1 );

    computeGeometry.setMode( computeMode );
    computeGeometry.initCalibration( sffFile.stereo_t,
				     sffFile.stereo_q,
				     sffFile.stereo_bl );
    computeGeometry.setWorldTransform
       ( qmVectorRef( 3, sffFile.world_t ),
	 qmMatrixRef( 3, 3, sffFile.world_r ),
	 sffFile.world_scale );

    // ** Set up the viewer
    Widget window;
    if( displayMode )
       {
	   window = personViewer.init( argv[0], width, height );
	   XtMoveWidget( window, x0, y0 );
	   personViewer.setViewTransform( sffFile.view_t,
					  sffFile.view_q, 
					  sffFile.view_heightAngle );
	   personViewer.initCalibration
 	      ( sffFile.stereo_t[0], sffFile.stereo_t[1], sffFile.stereo_t[2],
 		sffFile.stereo_q[0], sffFile.stereo_q[1], sffFile.stereo_q[2],
		sffFile.stereo_q[3], sffFile.stereo_bl );

	   personViewer.setWorldTransform( sffFile.world_t,
					   sffFile.world_r,
					   sffFile.world_scale );
	   personViewer.initWorld( "world.iv", libPath );
	   personViewer.mode = computeMode;
	   // personViewer.dumpScene(); exit(0);
       }


    if( serveMode )
       {
	   sffinderServer.init();
	   sffinderServer.start();
       }

    if( ffinderMode )
       {
	   // if( ffinderClient.connect( leftServerHost, rightServerHost ) )
	   if( ffinderClient.connect( sffFile.ffinder_left,
				      sffFile.ffinder_right ) )
	      exit( 1 );
       }

    if( undumpMode )
       {
	   personPlus.readRing( dumpFilename );
       }

    HowSlow howslow;
    int personState = personPlus.NoPerson;
    int undumpDir = personPlus.Forward;

    // dumping params
    static int dumpSkipCount = 0;
    static int dumpCount = 0;
    static int lastDumpFrame = 0;

    // ** Main loop
    // for( int frameCount = 0;; frameCount++ )
    for( int frameCount = -1;;  )
       {
	   if( sffinderServer.sleepFlag )
	      {
		  signal( SIGUSR1, ignore );
		  sigpause( SIGUSR1 );
		  sffinderServer.sleepFlag = 0;
		  if( displayMode )
		     XRaiseWindow( personViewer.getDisplay(), 
				   personViewer.getWindow() );
	      }

	   if( howslowMode )
	      howslow.sample();

	   if( displayMode )
	      {
		  personViewer.handle();
		  computeGeometry.setMode( personViewer.mode );
		  if( personViewer.quitFlag )
		     sffinderServer.cleanup();
		  if( personViewer.collectFlag )
		     {
			 undumpMode = 0;
			 ffinderMode = 1;
			 dumpMode = 1;
			 collectMode = 1;
			 dumpSkipCount = 0;
			 dumpCount = 0; 
			 lastDumpFrame = 0;
			 personPlus.initRing();
			 personViewer.stopInput = 0;
			 personViewer.jogInput = 0;
			 personViewer.collectFlag = 0;
		     }
		     
		  if( personViewer.calibrateFlag )
		     {
			 int ncorr;
			 float* data; // ncorr * 4
			 data = personPlus.getRingCorr( ncorr );
			 computeGeometry.calibrate( ncorr, data );
			 personViewer.initCalibration
			    ( computeGeometry.getCalibration() );
			 personViewer.calibrateFlag = 0;
		     }
		  if( personViewer.stopInput )
		     if( personViewer.jogInput )
			{
			    undumpDir = ( personViewer.jogInput < 0 ) ?
			       personPlus.Backward : personPlus.Forward;
			    personViewer.jogInput = 0;
			}
		     else
			continue;
	      }

	   if( undumpMode )
	      {
		  if( syncMode && sffinderServer.undumpFlag )
		     personPlus.undump_force(), sffinderServer.undumpFlag = 0;
		  else if( personViewer.stopInput )
		     personPlus.undump_force( undumpDir );
		  else
		     personPlus.undump_timed();

		  if( stateMode )
		     setState( personPlus, computeGeometry, personState );
		  if( undumpComputeMode )
		     computeGeometry.compute
			( personPlus.getYArray(),
			  personPlus.getValid(),
			  personPlus.getTArray(),
			  personPlus.getQArray(),
			  personPlus.getLArray(),
			  personPlus.getTWArray(),
			  personPlus.getQWArray(),
			  personPlus.getLWArray() );
		  frameCount = personPlus.getFrameNumber();
	      }
	   if( ffinderMode )
	      {
		  int oldframe = ffinderClient.callGetCurrent();
		  personPlus.set2( ffinderClient.getLeftPerson(),
				   ffinderClient.getRightPerson() );
		  if( stateMode )
		     setState( personPlus, computeGeometry, personState );

		  computeGeometry.compute
		     ( personPlus.getYArray(),
		       personPlus.getValid(),
		       personPlus.getTArray(),
		       personPlus.getQArray(),
		       personPlus.getLArray(),
		       personPlus.getTWArray(),
		       personPlus.getQWArray(),
		       personPlus.getLWArray() );
		  computeGeometry.computeQuickPoints
		     ( personPlus.getYArray(),
		       personPlus.getValid(),
		       personPlus.getQPArray() );

		  static struct timeval tv;
		  gettimeofday( &tv );
		  personPlus.setStamp( frameCount, tv.tv_sec, tv.tv_usec );
		  if( !oldframe )
		     frameCount++;
	      }
	   personPlus.findHands(); // computes the sffPerson

	   if( serveMode )
	      {
		  sffinderServer.copy( personPlus.get() );
		  sffinderServer.copy( personPlus.getHands() );
	      }

	   if( displayMode )
	      {
		  personViewer.setExistence( personPlus.personExists() );
		  personViewer.set( personPlus.getYArray(),
				    personPlus.getValid(),
				    personPlus.getTArray(),
				    personPlus.getQArray(),
				    personPlus.getLArray() );
		  personViewer.setHands( personPlus.getHandWhichAxis(),
					 personPlus.getHandMinus() );
		  personViewer.setFrameNumber( frameCount );
		  personViewer.setQuickPoints( personPlus.getQPArray() );
	      }

	   if( dumpMode )
	      {
		  // !! dump() wipes out personPlus
		  //    so this must go at end -- all done with personPlus!
		  if( verbose )
		     cerr << "\t" << dumpSkipCount - dumpSkip << endl;
		  dumpSkipCount++;
		  if( dumpSkipCount > dumpSkip &&
		      dumpCount < dumpNumber )
		     {
			 static char msg[ 256 ];
			 if( dumpSkipCount == dumpSkip+1 )
			    if( displayMode )
			       personViewer.setMessage( "COLLECTING FRAMES..." );
			 if( ( !noShitDump || 
			       ( frameCount != lastDumpFrame &&
			       personPlus.personExists() &&
				 personPlus.personFullyValid() ) )
			     && ( !moveDump || personPlus.moved2D() ) )
			    {
				if( displayMode )
				   sprintf( msg, "COLLECTING FRAMES...%d", dumpCount ),
				    personViewer.setMessage( msg );
				personPlus.dump();
				dumpCount++;
				lastDumpFrame = frameCount;
			    }
		     }
		  if( dumpCount >= dumpNumber )
		     {
			 // dumpFile.close();
			 if( collectMode )
			    {
				if( displayMode )
				   personViewer.clearMessage();
				dumpMode = 0;
				undumpMode = 1;
				ffinderMode = 0;
			    }
			 else
			    {
				personPlus.writeRing( dumpFilename );
				sffinderServer.cleanup();
			    }
		     }
	      }
       }
    // return 0;
}
