// glDisplay.c++

#include "glDisplay.h++"

#if 1
glDisplay::glDisplay( int h, int w, char *name, int p )
  : window( -1 ),
    height( h ),
    width( w ),
    packing( p )
{
    init( h, w, name, p );
#if 0
  foreground();
  prefsize( width, height );
  window = winopen( name );
  RGBmode();
  pixmode( PM_TTOB, 1 );
  if( YUV == packing )
     pixmode( PM_SIZE, 16 );
  gconfig();
#endif
}

glDisplay::~glDisplay()
{
    if( window != -1 )
       winclose( window );
}

void
glDisplay::init( int h, int w, char *name, int p )
{
    if( window != -1 )
       {
	   height = h; 
	   width = w;
	   packing = p;
	   foreground();
	   prefsize( width, height );
	   // prefposition( 0, width, 0, height );
	   window = winopen( name );
	   RGBmode();
	   pixmode( PM_TTOB, 1 );
	   if( YUV == packing )
	      pixmode( PM_SIZE, 16 );
	   gconfig();
       }
}

glDisplay&
glDisplay::operator=( unsigned long *p )
{
  lrectwrite( 0, 0, width-1, height-1, p );
  return *this;
}
#endif

#if 0
float glDisplay::polygon1[3][3] = { {-10.0, -10.0,   0.0,},
                         { 10.0, -10.0,   0.0,},
                         {-10.0,  10.0,   0.0,} };

float glDisplay::polygon2[3][3] = { {  0.0, -10.0, -10.0,},
                         {  0.0, -10.0,  10.0,},
                         {  0.0,   5.0, -10.0,} };

float glDisplay::polygon3[4][3] = { {-10.0,   6.0,   4.0,},
                         {-10.0,   3.0,   4.0,},
                         {  4.0,  -9.0, -10.0,},
                         {  4.0,  -6.0, -10.0,} };
String glDisplay::fallback_resources[] = {
	"*frame*shadowType: SHADOW_IN",
	    "*glwidget*width: 300",
	    "*glwidget*height: 300",
	    "*glwidget*rgba: TRUE",
	    "*glwidget*allocateBackground: TRUE",
	    NULL
	   };
XtAppContext glDisplay::app_context;
GLXContext glDisplay::glx_context;

glDisplay::glDisplay( int w, int h, char*, int )
  : picture( 0 ),
    width( w ),
    height( h )
{
    int argc = 1;
    static char*  argv[] = { "hello" };

    toplevel = XtAppInitialize(&app_context, "4DgiftsGLw", 
			       (XrmOptionDescList) NULL, 
			       (Cardinal)0,
			       (int *)&argc, 
			       (String*)argv, 
			       fallback_resources,
			       (ArgList)NULL, 0);

    n = 0;
    form = XmCreateForm(toplevel, "form", args, n);
    XtManageChild(form);

    n = 0;
    XtSetArg(args[n], XtNx, 30); n++;
    XtSetArg(args[n], XtNy, 30); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftOffset, 30); n++;
    XtSetArg(args[n], XmNtopOffset, 30); n++;
    XtSetArg(args[n], XmNbottomOffset, 30); n++;
    XtSetArg(args[n], XmNrightOffset, 30); n++;
    frame = XmCreateFrame (form, "frame", args, n);
    XtManageChild (frame);

    n = 0;
    glw = GLwCreateMDrawingArea(frame, "glwidget", args, n);
    XtManageChild (glw);
    XtAddCallback(glw, GLwNexposeCallback, draw_scene_callback, this);
    XtAddCallback(glw, GLwNresizeCallback, do_resize, 0);
    XtAddCallback(glw, GLwNginitCallback, init_window, 0);
    XtAddCallback(glw, GLwNinputCallback, input, 0);

    XtRealizeWidget(toplevel);
}

void
glDisplay::mainLoop()
{
    XtAppMainLoop(app_context);
}

void
glDisplay::init_window(Widget w, XtPointer, XtPointer)
{
    Arg args[1];
    XVisualInfo *vi;

    XtSetArg(args[0], GLwNvisualInfo, &vi);
    XtGetValues(w, args, 1);

    glx_context = glXCreateContext(XtDisplay(w), vi, 0, GL_FALSE);
}


void
glDisplay::draw_scene_callback(Widget w, XtPointer p, XtPointer)
{
    GLwDrawingAreaMakeCurrent(w, glx_context);
    glDisplay* gld = (glDisplay *) p;
    draw_scene( gld );
}

void
glDisplay::do_resize( Widget, XtPointer, XtPointer call_dataA )
{
    GLwDrawingAreaCallbackStruct *call_data = 
       ( GLwDrawingAreaCallbackStruct * ) call_dataA;
    glViewport(0, 0, (GLint)call_data->width-1, (GLint)call_data->height-1);
}

void
glDisplay::draw_scene( glDisplay* gld )
{
    static unsigned char *buf = 0;
    // int width = 128;
    // int height = 128;
    int npixels = gld->width*gld->height;
    int nbytes = npixels * 3;
    int i;
    // GLfloat current[4] = { -.5, -.375, 0., 1. };
    GLfloat current[4] = { -60, 20, 0., 1. };

#if 0
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();
    gluPerspective(40.0, 1.0, 30.0, 1000.0);
    glTranslatef(0.0, 0.0, -40.0);
    glRotatef(-58.0, 0,1,0);
    draw_polys();
    glFlush();
#endif
    // glEnable(GL_DEPTH_TEST);
    // glDepthFunc(GL_LEQUAL);
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    // glLoadIdentity();
    gluPerspective(40.0, 1.0, 30.0, 1000.0);
    glTranslatef(0.0, 0.0, -40.0);
    glRotatef(-58.0, 0,1,0);
    // draw_polys();
    glFlush();

    if( !buf )
       {
	   unsigned char* ucp;
	   buf = new unsigned char[ nbytes ];
	   ucp = buf;
	   for( i = 0; i < npixels; i++ )
	      {
		  *ucp++ = i % gld->width;
		  *ucp++ = i % gld->width;
		  *ucp++ = 0;
	      }
       }

    glPushAttrib( GL_ALL_ATTRIB_BITS );
    glDisable( GL_LIGHTING ); 
    glDepthMask( GL_FALSE );
    glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
    glPixelStorei( GL_UNPACK_ROW_LENGTH, gld->width );
    glRasterPos4fv( current );
    glPixelZoom( 1, -1 );
#if 0
    glDrawPixels( gld->width,
		 gld->height,
		 GL_RGB,
		 GL_UNSIGNED_BYTE,
		 (gld->picture) ? gld->picture : buf );
#endif
    glDrawPixels( gld->width,
		 gld->height,
		 GL_ABGR_EXT,
		 GL_UNSIGNED_BYTE,
		 (gld->picture) ? gld->picture : buf );
    glDepthMask( GL_TRUE );
    glEnable( GL_LIGHTING );   
    glPopAttrib();
    glFlush();

}

void
glDisplay::draw_polys() {
    glBegin(GL_POLYGON);
        glColor3f(0.0, 0.0, 0.0);
        glVertex3fv(&polygon1[0][0]);
        glColor3f(0.7, 0.7, 0.7);
        glVertex3fv(&polygon1[1][0]);
        glColor3f(1.0, 1.0, 1.0);
        glVertex3fv(&polygon1[2][0]);
    glEnd();
    glBegin(GL_POLYGON);
        glColor3f(1.0, 1.0, 0.0);
	glVertex3fv(&polygon2[0][0]);
	glColor3f(0.0, 1.0, 0.7);
	glVertex3fv(&polygon2[1][0]);
	glColor3f(0.0, 0.0, 1.0);
	glVertex3fv(&polygon2[2][0]);
    glEnd();
    glBegin(GL_POLYGON);
        glColor3f(1.0, 1.0, 0.0);
	glVertex3fv(&polygon3[0][0]);
	glColor3f(1.0, 0.0, 1.0);
	glVertex3fv(&polygon3[1][0]);
	glColor3f(0.0, 0.0, 1.0);
	glVertex3fv(&polygon3[2][0]);
	glColor3f(1.0, 0.0, 1.0);
	glVertex3fv(&polygon3[3][0]);
    glEnd();
}

/* Process all Input callbacks*/
void
glDisplay::input( Widget , XtPointer, XtPointer ack )
{
    GLwDrawingAreaCallbackStruct *call_data = 
       ( GLwDrawingAreaCallbackStruct * ) ack;
    char buffer[1];
    KeySym keysym;

    switch(call_data->event->type)
    {
    case KeyRelease:
	/* It is necessary to convert the keycode to a keysym before
	 * it is possible to check if it is an escape
	 */
	if (XLookupString((XKeyEvent *) call_data->event,buffer,1,&keysym,NULL)
	    == 1 && keysym == (KeySym)XK_Escape)
	    exit(0);
	break;
    }
}

glDisplay&
glDisplay::operator=( unsigned char *p )
{
    picture = p;
    draw_scene( this );
    return *this;
}

void
glDisplay::handle()
{
    XtInputMask m;
    while( m = XtAppPending( app_context ) )
       XtAppProcessEvent( app_context, m );
}
#endif
