// vliYUVImage.c++

#include "vlImage/vliYUVImage.h++"

vliYUVImage::vliYUVImage( int w, int h )
  : vliYUVImageRef( w, h, 0 ),
    allocArray( new byte[ w * h * vliYUVBytesPerPixel ] )
{
    data = allocArray;
}

vliYUVImage::vliYUVImage( const vliYUVImage& src )
  : vliYUVImageRef( 0, 0, 0 ),
    allocArray( 0 )
{
    set( src );
}

vliYUVImage::vliYUVImage( const vliYUVImageRef& src )
  : vliYUVImageRef( 0, 0, 0 ),
    allocArray( 0 )
{
    set( src );
}

void
vliYUVImage::set( const vliYUVImageRef& src )
{
    if( allocArray && pixelCount < src.getPixelCount() )
       { 
	   delete allocArray;
	   allocArray = 0;
       }
    if( !allocArray )
       allocArray = new byte[ src.getPixelCount() * vliYUVBytesPerPixel ];
    pixelCount = src.getPixelCount();
    width = src.getWidth();
    bytesPerPixel = vliYUVBytesPerPixel;
    data = allocArray;
    copy( src );
}

void
vliYUVImage::set( int w, int h )
{
    if( allocArray && pixelCount < w*h )
       { 
	   delete allocArray;
	   allocArray = 0;
       }
    if( !allocArray )
       allocArray = new byte[ w * h * vliYUVBytesPerPixel ];
    pixelCount = w*h;
    width = w;
    bytesPerPixel = vliYUVBytesPerPixel;
    data = allocArray;
}

